<script setup lang="ts">
import { useQuasar, type QTableColumn } from "quasar";
import { ref, onMounted, computed } from "vue";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { useDataStore } from "@/stores/data";
import { useGovernmentPosDataStore } from "@/modules/10_registry/store/Position";

import type {
  SalaryFormType,
  CardDataPos,
} from "@/modules/10_registry/interface/index/Main";
import type { DataCommandCode } from "@/modules/10_registry/interface/response/Main";

//history dialog
import DialogHistory from "@/modules/10_registry/Dialog/DialogHistory.vue";

const link = ref<string>("");
const $q = useQuasar();
const dataPerson = useDataStore();
const store = useGovernmentPosDataStore();
const mixin = useCounterMixin();
const {
  showLoader,
  hideLoader,
  messageError,
  date2Thai,
  onSearchDataTable,
  formatDatePosition,
  findOrgName,
  findOrgNameHtml,
} = mixin;

const idByRow = ref<string>("");
const rows = ref<SalaryFormType[]>([]);
const rowsData = ref<SalaryFormType[]>([]);
const filter = ref<string>("");
const rowsHistory = ref<SalaryFormType[]>([]);
const rowsHistoryData = ref<SalaryFormType[]>([]);
const mode = ref<boolean>($q.screen.gt.xs);
const checkType = ref<boolean>(
  dataPerson.officerType == "OFFICER" ? true : false
);
const modalHistory = ref<boolean>(false);
const cardData = ref<CardDataPos[]>([
  {
    label: "ระยะเวลาดำรงตำแหน่งในสายงาน",
    data: [],
  },
  {
    label: "ระยะเวลาดำรงตำแหน่งตามระดับ",
    data: [],
  },
  {
    label: "ระยะเวลาดำรงตำแหน่งทางการบริหาร",
    data: [],
  },
]);

const baseColumns = ref<QTableColumn[]>([
  {
    name: "commandDateAffect",
    align: "left",
    label: "วันที่คำสั่งมีผล",
    sortable: true,
    field: "commandDateAffect",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "commandDateSign",
    align: "left",
    label: "วันที่ลงนาม",
    sortable: true,
    field: "commandDateSign",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posNumCodeSit",
    align: "left",
    label: "หน่วยงานที่ออกคำสั่ง",
    sortable: false,
    field: "posNumCodeSit",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return row.posNumCodeSitAbb && row.posNumCodeSit
        ? `${row.posNumCodeSit} (${row.posNumCodeSitAbb})`
        : row.posNumCodeSit
        ? row.posNumCodeSit
        : "-";
    },
  },
  {
    name: "posNo",
    align: "left",
    label: link.value === "-employee" ? "ตำแหน่งเลขที่" : "เลขที่ตำแหน่ง",
    sortable: true,
    field: "posNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return row.posNoAbb && row.posNo
        ? `${row.posNoAbb} ${row.posNo}`
        : row.posNo
        ? row.posNo
        : "-";
    },
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "positionName",
    align: "left",
    label: link.value === "-employee" ? "ตำแหน่ง" : "ตำแหน่งในสายงาน",
    sortable: true,
    field: "positionName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "positionType",
    align: "left",
    label: link.value === "-employee" ? "กลุ่มงาน" : "ตำแหน่งประเภท",
    sortable: true,
    field: "positionType",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "positionLevel",
    align: "left",
    label: link.value === "-employee" ? "ระดับชั้นงาน" : "ระดับ",
    sortable: true,
    field: "positionLevel",
    format(val, row) {
      return `${
        row.positionLevel
          ? row.positionLevel
          : row.positionCee
          ? row.positionCee
          : "-"
      }`;
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "positionExecutive",
    align: "left",
    label: "ตำแหน่งทางการบริหาร",
    sortable: true,
    field: "positionExecutive",
    format(val, row) {
      return !row.positionExecutiveField
        ? val
        : `${val} (${row.positionExecutiveField})`;
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "commandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "commandNo",
    format(val, row) {
      return row.commandNo && row.commandYear
        ? row.commandType !== "C-PM-47"
          ? `${row.commandNo}/${Number(row.commandYear) + 543}`
          : `${row.commandNo}`
        : "";
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "commandName",
    align: "left",
    label: "ประเภทคำสั่ง",
    sortable: true,
    field: "commandName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "organization",
    align: "left",
    label: "สังกัด",
    sortable: true,
    field: "organization",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return findOrgName({
        root: row.orgRoot,
        child1: row.orgChild1,
        child2: row.orgChild2,
        child3: row.orgChild3,
        child4: row.orgChild4,
      });
    },
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "amount",
    align: "left",
    label: link.value === "-employee" ? "ค่าจ้าง" : "เงินเดือน",
    sortable: true,
    field: "amount",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(v, row) {
      return row.amount
        ? `${row.amount.toLocaleString()}${
            row.amountSpecial !== 0 && row.amountSpecial
              ? ` (${row.amountSpecial.toLocaleString()})`
              : ""
          }`
        : "-";
    },
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "remark",
    align: "left",
    label: "หมายเหตุ",
    sortable: true,
    field: "remark",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const baseVisibleColumns = ref<string[]>([
  "commandDateAffect",
  "posNumCodeSit",
  "posNo",
  "positionName",
  "positionType",
  "positionLevel",
  "positionExecutive",
  "amount",
  "commandNo",
  "commandName",
  "commandDateSign",
  "organization",
  "remark",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);

const columns = computed<QTableColumn[]>(() => {
  if (!checkType.value) {
    if (baseColumns.value) {
      return baseColumns.value.filter(
        (column) =>
          column.name !== "positionExecutive" &&
          column.name !== "lastUpdateFullName" &&
          column.name !== "lastUpdatedAt"
      );
    }
  }
  return baseColumns.value.filter(
    (e: QTableColumn) =>
      e.name !== "lastUpdateFullName" && e.name !== "lastUpdatedAt"
  );
});
const visibleColumns = ref<String[]>(
  baseVisibleColumns.value.filter(
    (e: string) => e !== "lastUpdateFullName" && e !== "lastUpdatedAt"
  )
);
const columnsHistory = computed<QTableColumn[]>(() => {
  if (!checkType.value) {
    if (baseColumns.value) {
      return baseColumns.value.filter(
        (column) => column.name !== "positionExecutive"
      );
    }
  }
  return baseColumns.value;
});
const visibleColumnsHistory = ref<string[]>(baseVisibleColumns.value);

/** เปิด dialog ประวัติ*/
function onHistory(id: string) {
  modalHistory.value = true;
  idByRow.value = id;
}

/** get data */
function getData() {
  showLoader();
  http
    .get(config.API.dataUserPosition(link.value))
    .then((res) => {
      const data = res.data.result;
      rows.value = data;
      rowsData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/** get history */
function getHistory() {
  showLoader();
  http
    .get(config.API.dataUserSalaryHistoryByType(link.value, idByRow.value))
    .then((res) => {
      const data = res.data.result;
      rowsHistory.value = data;
      rowsHistoryData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

function onSearch() {
  rows.value = onSearchDataTable(
    filter.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

async function fetchDataTenure() {
  console.log(link.value);

  await http
    .get(config.API.salaryTenurePosition(link.value))
    .then((res) => {
      const data = res.data.result;
      if (data) {
        // map ข้อมูลระยะเวลาดำรงตำแหน่ง
        const formatData = (list: any) =>
          list.map((e: any) => ({
            name: e.name ?? "",
            time: formatDatePosition(e.year, e.month, e.day),
          }));

        // แปลงข้อมูลจาก data
        const position = data.position ? formatData(data.position) : []; //ระยะเวลาดำรงตำแหน่งในสายงาน
        const posLevel = data.posLevel ? formatData(data.posLevel) : []; //ระยะเวลาดำรงตำแหน่งตามระดับ
        const posExecutive = data.posExecutive
          ? formatData(data.posExecutive)
          : []; //ระยะเวลาดำรงตำแหน่งทางการบริหาร

        // นำข้อมูลไปใส่ใน cardData
        cardData.value[0].data = position;
        cardData.value[1].data = posLevel;
        if (link.value !== "-employee") {
          cardData.value[2].data = posExecutive;
        }

        //เช็คค่า ระยะเวลาดำรงตำแหน่งทางการบริหาร ถ้าไม่มีให้ลบออกจาก cardData
        if (
          posExecutive.length === 0 &&
          link.value !== "-employee" &&
          cardData.value.length > 2
        ) {
          cardData.value.splice(2, 1);
        }
      }
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** function fetch ข้อมูลประเภทคำสั่ง*/
async function fetchDataCommandCode() {
  if (store.commandCodeData.length > 0) return false;
  await http
    .get(config.API.orgCommandCode)
    .then((res) => {
      const data = res.data.result;
      const DataCommandCode = data.filter((e: DataCommandCode) =>
        store.positionCode.includes(e.code)
      );

      const options = DataCommandCode.map((e: DataCommandCode) => ({
        id: e.code.toString(),
        name: e.name,
      }));

      store.commandCodeData = options;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

onMounted(async () => {
  link.value = await dataPerson.getProFileType();
  if (link.value === "-employee") {
    cardData.value.splice(2, 1);
  }
  getData();
  fetchDataTenure();
  fetchDataCommandCode();
});
</script>

<template>
  <!-- v-if="mode" -->
  <div class="col-12">
    <q-toolbar class="q-px-none">
      <span class="text-blue-6 text-weight-bold text-body1">ตำแหน่ง</span>
    </q-toolbar>

    <div class="row q-col-gutter-sm q-pb-sm">
      <div class="col" v-for="(item, index) in cardData" :key="index">
        <q-card bordered class="col-12" style="border: 1px solid #d6dee1">
          <div class="col-12 text-weight-medium bg-grey-1 q-py-xs q-px-md">
            {{ item.label }}
          </div>
          <div class="col-12"><q-separator /></div>
          <q-card-section class="q-pt-none" style="min-height: 200px">
            <li v-for="data in item.data">{{ data.name }} {{ data.time }}</li>
          </q-card-section>
        </q-card>
      </div>
    </div>

    <div class="row col-12">
      <q-space />
      <q-input
        v-if="mode"
        class="inputgreen"
        outlined
        dense
        v-model="filter"
        label="ค้นหา"
        style="max-width: 200px"
        @keydown.enter.prevent="onSearch"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-if="mode"
        class="q-ml-sm"
        dense
        multiple
        outlined
        emit-value
        map-options
        options-dense
        option-value="name"
        style="min-width: 140px"
        v-model="visibleColumns"
        :options="columns"
        :display-value="$q.lang.table.columns"
      />
    </div>

    <div class="col-12 q-mt-sm">
      <d-table
        flat
        dense
        bordered
        virtual-scroll
        :rows="rows.length !== 0 ? rows : []"
        :columns="columns"
        :grid="!mode"
        :rows-per-page-options="[10, 25, 50, 100]"
        :visible-columns="visibleColumns"
        :virtual-scroll-sticky-size-start="48"
      >
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
            <q-th auto-width />
          </q-tr>
        </template>

        <template v-if="mode" v-slot:body="props">
          <q-tr :props="props" class="cursor-pointer">
            <q-td
              v-for="(col, index) in props.cols"
              :key="col.name"
              :class="props.row.isEntry ? 'text-red' : ''"
            >
              <div v-if="col.name == 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div v-else-if="col.name == 'status'">
                {{ props.row.status ? props.row.status : "-" }}
              </div>
              <div
                v-else-if="col.name == 'organization'"
                class="text-html"
                style="width: 300px"
              >
                {{
                  props.row
                    ? findOrgNameHtml({
                        root: props.row.orgRoot,
                        child1: props.row.orgChild1,
                        child2: props.row.orgChild2,
                        child3: props.row.orgChild3,
                        child4: props.row.orgChild4,
                      })
                    : "-"
                }}
              </div>
              <div v-else>
                {{ col.value ? col.value : "-" }}
              </div>
            </q-td>
            <q-td auto-width>
              <q-btn
                color="info"
                flat
                dense
                round
                size="14px"
                icon="mdi-history"
                @click="onHistory(props.row.id)"
              >
                <q-tooltip>ประวัติแก้ไขตำแหน่ง</q-tooltip>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
        <template v-else v-slot:item="props">
          <div class="q-mb-xs col-xs-12 col-sm-6 col-md-4 col-lg-3">
            <q-card bordered flat>
              <q-list dense class="q-mt-lg relative-position">
                <q-btn
                  icon="mdi-history"
                  color="info"
                  flat
                  dense
                  round
                  size="14px"
                  class="absolute_button"
                  @click="onHistory(props.row.id)"
                >
                  <q-tooltip>ประวัติแก้ไขตำแหน่ง</q-tooltip>
                </q-btn>
                <q-item v-for="col in props.cols" :key="col.name">
                  <q-item-section class="fix_top">
                    <q-item-label class="text-grey-6 text-weight-medium">{{
                      col.label
                    }}</q-item-label>
                  </q-item-section>
                  <q-item-section
                    v-if="col.name == 'organization'"
                    class="fix_top text-html"
                  >
                    <q-item-label class="text-dark text-weight-medium">
                      {{
                        props.row
                          ? findOrgNameHtml({
                              root: props.row.orgRoot,
                              child1: props.row.orgChild1,
                              child2: props.row.orgChild2,
                              child3: props.row.orgChild3,
                              child4: props.row.orgChild4,
                            })
                          : "-"
                      }}</q-item-label
                    >
                  </q-item-section>
                  <q-item-section v-else class="fix_top">
                    <q-item-label class="text-dark text-weight-medium">{{
                      col.value ? col.value : "-"
                    }}</q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-card>
          </div>
        </template>
      </d-table>
    </div>
  </div>

  <DialogHistory
    v-model:modal="modalHistory"
    :title="'ตำแหน่ง'"
    :getData="getHistory"
    :rows="rowsHistory"
    :rows-data="rowsHistoryData"
    :visibleColumns="visibleColumnsHistory"
    :columns="columnsHistory"
  />
</template>
<style scoped>
.absolute_button {
  position: absolute;
  right: 5px;
  top: -20px;
}

.fix_top {
  justify-content: start !important;
}
</style>
